#ifndef L2DEFSPRITE
#define L2DEFSPRITE

#include <GL/freeglut.h>
#include <list>
#include "L2FileHndl.h"

//int CheckFileValidity()

#define L2CL 0 //(palette)
#define L2SS 1 //(special-object sprites)
#define L2SF 2 //(special-object-frame data)
#define L2SA 3 //(special-object-frame data pointers)
#define L2SI 4 //(special-object-frame arrangement pointers)
#define L2BE 5 //(terrain tile arrangement)
#define L2OB 6 //(object information)
#define L2BF 7 //(animation-frame data)
#define L2BA 8 //(animation-frame data pointers)
#define L2BI 9 //(animation-frame arrangement pointers)
#define L2BL 10 //(8*16 sprites)
#define L2BS 11 //(preview 2*1 sprites)

/*struct SpriteData
{
    unsigned char PixelData[16][8][3];
};*/

class CDefSprite {
public:
    //CDefSprite() {}
    void GenerateSprites(FILE* StyleFile); //+ transform into Textures
    //function to return offset to stuff
	void DrawSprite(int x, int y, int ID, bool BackgroundDraw);
	    //BackgroundDraw y/n;
	//void WriteTileToData();
public:
    //std::list<SpriteData> SpriteList;
    //int xSize, ySize;
    int SpriteAmount;
    GLuint TextureBuffer[1024];        //at most 1024 sprites
};

void CDefSprite::GenerateSprites(FILE* StyleFile)
{

    GLubyte PaletteData[128][3];   //128   Entries
    GLubyte SingleSprite[128][4];  //16*8  Pixels
    
    //std::list<SpriteData>::iterator SpriteIterator = SpriteList.begin();
    
    /* get palette */
    int offset = GetSectionOffset(StyleFile, L2CL);
    fseek(StyleFile, offset+0x0a, SEEK_SET);
    for(int i=0; i<128; i++)
    {
        fread(&PaletteData[i], sizeof(unsigned char), 3, StyleFile);
        for(int j=0; j<3; j++)
            PaletteData[i][j] *= 4;
    }

    /* get sprites & textures */
    offset = GetSectionOffset(StyleFile, L2BL);
    fseek(StyleFile, offset+0x08, SEEK_SET);
    SpriteAmount = ReadValue(StyleFile, 2, 'l');
    glGenTextures(SpriteAmount, TextureBuffer); //new GLuint
    
    for(int j=0; j<SpriteAmount; j++)
    {
        for(int i=0; i<128; i++)
        {
            char byte = fgetc(StyleFile);
            for(int k=0; k<3; k++) SingleSprite[16*((i/4)%8) + (4*i)%16+i/32][k] = PaletteData[byte][k];
            SingleSprite[i][3]=0xFF;
        }
        glBindTexture(GL_TEXTURE_2D, TextureBuffer[j]);
        glTexImage2D(GL_TEXTURE_2D, 0, 3, 16, 8, 0, GL_RGBA, GL_UNSIGNED_BYTE, SingleSprite);        
    }
}

void CDefSprite::DrawSprite(int x, int y, int ID, bool BackgroundDraw)
{
    glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D, TextureBuffer[ID]);
        //glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
        //glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);

    glBlendFunc(GL_SRC_ALPHA,GL_ONE);
    glColor4f(1.0, 1.0, 1.0, 0.8);
    
    if(BackgroundDraw) glEnable(GL_BLEND);

    glBegin(GL_QUADS);
    glTexCoord2f(0, 0); glVertex2f(x, y);
    glTexCoord2f(0, 1); glVertex2f(x, y+8);
    glTexCoord2f(1, 1); glVertex2f(x+16, y+8);
    glTexCoord2f(1, 0); glVertex2f(x+16, y);
    glEnd();
    
    if(BackgroundDraw) glDisable(GL_BLEND);

    glDisable(GL_TEXTURE_2D);
}

CDefSprite* SpriteData = NULL;

#endif
