#ifndef L2WMAIN
#define L2WMAIN

#include <GL/freeglut.h>
#include "L2DefSprite.h"
#include "L2DefObj.h"
#include "L2LData.h"
#include "L2WSprite.h"
#include <vector>

#define MODE_NODRAW 0
#define MODE_SPRITE 1
#define MODE_TILE   2
#define MODE_OBJECT 3
#define MODE_SELECT 4

using namespace std;

class CWinMain {
public:
	CWinMain(int w, int h, int x, int y);
    static void Display();
	static void KeyProcessing(unsigned char key, int x, int y);
	static void SpecialKeyProcessing(int key, int x, int y);
	static void Reshape(int w, int h);
	void DrawLevelArea();
	void MouseToPos();
	static void Mouse(int button, int state, int x, int y);
	static void MouseMovement(int x, int y); //int button, int state, 
	//Rectangle Drawing Adjustment (Zoom/Shift)
    static void DrawMapSect(int x1, int y1, int x2, int y2);
    static void ClearDrawObject(int xPos, int yPos, int xExtension, int yExtension, int ID);
    static void DrawCurrentObject(int border_mode);
    static void ClearDrawCurrentObject();
    static void DrawMode();
    static void SetMode(int modeID);
	
public:
    int Mode;
    int SelectedObjectID;
    bool BackgroundDraw;
    //Selection (Rectangle)
    //SelObject
    //SelSprite
    //SelTile
    //Press Key 0-4 for enforcing mode selection

    int xShift, yShift;
    int PosX, PosY;
    int MouseX, MouseXPrevious;
    int MouseY, MouseYPrevious;
    int MouseButton, MouseButtonPrevious;
    int MouseState;

};

CWinMain* MainWindow = NULL;

#endif
