#ifndef L2WDOBJECT
#define L2WDOBJECT

#include "L2WObject.h"

CWinObject::CWinObject(int w, int h, int x, int y)  //initialize
{
    glutInitWindowSize(w, h);
    glutInitWindowPosition(x, y);
    OBJ_WIN = glutCreateWindow("Object Window");
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
	gluOrtho2D(0, w, h, 0);
    glClearColor(0.0, 0.0, 0.0, 1.0);
    
    //Zoom=1;
    SelectedObject = 0;
    yShift = 0;
    //xShift=0; yShift=0;
    //SpritesPerLine=5;
    
    glutDisplayFunc(Display);
    //glutKeyboardFunc(KeyProcessing);
    //glutSpecialFunc(SpecialKeyProcessing);
    glutReshapeFunc(Reshape);
    glutMouseFunc(Mouse);
    //glutMotionFunc(MouseMovement);
}

void CWinObject::Display()
{
    glClear(GL_COLOR_BUFFER_BIT);
    
    int y=0;
    for(int i=0; i<ObjectData->ObjectAmount; i++)
    {
         ObjectData->DrawObject(0, y, 0, 0, i, BORDER_NORMAL);
         y += ObjectData->ObjectList[i]->yMax + 1;
    }

    glFlush();
}

void CWinObject::Reshape(int w, int h)
{
    glViewport(0, 0, w, h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluOrtho2D(0, w, h, 0);
}

void CWinObject::Mouse(int button, int state, int x, int y)
{
    if(state == GLUT_DOWN)
    {
        /*switch(button)
        {
            case GLUT_LEFT_BUTTON:
                 break;
            case GLUT_RIGHT_BUTTON:
                 break;
            default: return;           
        }*/
        //glColor3f(1.0, 1.0, 1.0);
        //drawRect(sZoom*16*(x/(16*sZoom)), sZoom*8*(y/(8*sZoom)), 16*sZoom-1, 8*sZoom-1);
        ObjectWindow->SelectedObject = ObjectWindow->DetectObject(y);
        MainWindow->Mode = MODE_OBJECT;
    }
}

int CWinObject::DetectObject(int y)
{
    int yCheck=0, i=-1;
    do{
        i++;
        if(i > ObjectData->ObjectAmount - 1) return ObjectData->ObjectAmount - 1;
        yCheck += ObjectData->ObjectList[i]->yMax + 1;
    }while(yCheck < y);
    return i;
}

#endif
