#ifndef L2WDSPRITE
#define L2WDSPRITE

#include "L2WSprite.h"
#include "L2DefSprite.h"

CWinSprite::CWinSprite(int w, int h, int x, int y)  //initialize
{
    glutInitWindowSize(w, h);
    glutInitWindowPosition(x, y);
    SPRITE_WIN = glutCreateWindow("Sprite Window");
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
	gluOrtho2D(0, w, h, 0);
    glClearColor(0.0, 0.0, 0.0, 1.0);
    
    Zoom=1;
    yShift = 0;
    //xShift=0; yShift=0;
    SpritesPerLine=5;
    
    glutDisplayFunc(Display);
    //glutKeyboardFunc(KeyProcessing);
    //glutSpecialFunc(SpecialKeyProcessing);
    glutReshapeFunc(Reshape);
    glutMouseFunc(Mouse);
    //glutMotionFunc(MouseMovement);
}

void CWinSprite::Display()
{
    glClear(GL_COLOR_BUFFER_BIT);
    
    int x=0, y=0;
    for(int i=0; i<SpriteData->SpriteAmount; i++)
    {
        SpriteData->DrawSprite(16*x, 8*y, i, false);
        x++;
        if(x>=SpriteWindow->SpritesPerLine) {y++; x=0;}
    }
    //glPixelZoom(Zoom, -Zoom);

    glFlush();
}

void CWinSprite::Reshape(int w, int h)
{
    if(w != (w - w%(16*SpriteWindow->Zoom))) 
    {
        w = w+8*SpriteWindow->Zoom - (w+8*SpriteWindow->Zoom)%(16*SpriteWindow->Zoom);
        if(w<120) w += 16*SpriteWindow->Zoom;
        glutReshapeWindow(w, h);
        return;
    }
    glViewport(0, 0, w, h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluOrtho2D(0, w, h, 0);
    SpriteWindow->SpritesPerLine = w/(16*SpriteWindow->Zoom);
}

void CWinSprite::Mouse(int button, int state, int x, int y)
{
    if(state == GLUT_DOWN)
    {
        /*switch(button)
        {
            case GLUT_LEFT_BUTTON:
                 SpriteWindow->BackgroundDraw = false;
                 break;
            case GLUT_RIGHT_BUTTON:
                 SpriteWindow->BackgroundDraw = true;     
                 break;
            default: return;           
        }*/
        glColor3f(1.0, 1.0, 1.0);
        DrawRect(SpriteWindow->Zoom*16*(x/(16*SpriteWindow->Zoom)), SpriteWindow->Zoom*8*(y/(8*SpriteWindow->Zoom)), 16*SpriteWindow->Zoom-1, 8*SpriteWindow->Zoom-1);
        SpriteWindow->SelectedSprite = SpriteWindow->SpritesPerLine*(y/(8*SpriteWindow->Zoom - SpriteWindow->yShift)) + x/(16*SpriteWindow->Zoom);
        MainWindow->Mode = MODE_SPRITE;
        glFlush();
    }
}

/*void CWinSprite::KeyProcessing(unsigned char key, int x, int y)
{
    switch(key)
    {
        case '+':
             if(SpriteWindow->Zoom<3)
             {
                 SpriteWindow->Zoom++;
                 sSpritesPerLine = sSpritesPerLine * (SpriteWindow->Zoom-1) / (SpriteWindow->Zoom);
             }
             break;
        case '-':
             if(SpriteWindow->Zoom>1)
             {
                 SpriteWindow->Zoom--;
                 sSpritesPerLine = sSpritesPerLine * (SpriteWindow->Zoom + 1) / (SpriteWindow->Zoom);
             }
             break;
        default: return;
    }
    glutPostRedisplay();
}*/

/*void CWinSprite::SpecialKeyProcessing(int key, int x, int y)
{
    switch(key)
    {
        case GLUT_KEY_UP:
             if(sTileY > 0) sTileY--;
             break;
        case GLUT_KEY_DOWN:
             if(sTileY < spriteAmount/sSpritesPerLine) sTileY++;
             break;
        default: return;
    }
    glutPostRedisplay();
}*/

#endif
