#ifndef L2WDTILE
#define L2WDTILE

#include "L2WTile.h"

CWinTile::CWinTile(int w, int h, int x, int y)  //initialize
{
    glutInitWindowSize(w, h);
    glutInitWindowPosition(x, y);
    TILE_WIN = glutCreateWindow("Tile Window");
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
	gluOrtho2D(0, w, h, 0);
    glClearColor(0.0, 0.0, 0.0, 1.0);
    
    Zoom=1;
    yShift = 0;
    //xShift=0; yShift=0;
    //SpritesPerLine=5;
    
    glutDisplayFunc(Display);
    //glutKeyboardFunc(KeyProcessing);
    glutSpecialFunc(SpecialKeyProcessing);
    glutReshapeFunc(Reshape);
    glutMouseFunc(Mouse);
    //glutMotionFunc(MouseMovement);
}

void CWinTile::Display()
{
    glClear(GL_COLOR_BUFFER_BIT);
    
    int y = 0;
    for(int i=TileWindow->yShift; i<TileData->TileAmount; i++)
    {
        TileData->DrawTile(0, y, i, false);
        y += 8*TileData->TileList[i]->ySize + 1;
    }
    //glPixelZoom(sZoom, -sZoom);

    glFlush();
}

void CWinTile::Reshape(int w, int h)
{
    glViewport(0, 0, w, h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluOrtho2D(0, w, h, 0);
}

void CWinTile::SpecialKeyProcessing(int key, int x, int y)
{
    switch(key)
    {
        case GLUT_KEY_UP:
             if(TileWindow->yShift > 0) TileWindow->yShift--;
             break;
        case GLUT_KEY_DOWN:
             if(TileWindow->yShift + 1 < TileData->TileAmount) TileWindow->yShift++;
             break;
        default: return;
    }
    glutPostRedisplay();
}

void CWinTile::Mouse(int button, int state, int x, int y)
{
    if(state == GLUT_DOWN)
    {
        /*switch(button)
        {
            case GLUT_LEFT_BUTTON:
                 TileWindow->BackgroundDraw = false;
                 break;
            case GLUT_RIGHT_BUTTON:
                 TileWindow->BackgroundDraw = true;     
                 break;
            default: return;           
        }*/
        //glColor3f(1.0, 1.0, 1.0);
        //drawRect(sZoom*16*(x/(16*sZoom)), sZoom*8*(y/(8*sZoom)), 16*sZoom-1, 8*sZoom-1);
        TileWindow->SelectedTile = TileWindow->DetectTile(y);
        MainWindow->Mode = MODE_TILE;
    }
}


int CWinTile::DetectTile(int y)
{
    int yCheck=0;
    int i = yShift-1;
    do{
        i++;
        if(i > TileData->TileAmount - 1) return TileData->TileAmount - 1;
        yCheck += 8*TileData->TileList[i]->ySize + 1;
    }while(yCheck < y);
    return i;
}

/*
void tile_display()
{
    int i, j;
    int x=0, y=0;
    int tileDataCounter;
    
    glPixelZoom(tZoom, -tZoom);
    glClear(GL_COLOR_BUFFER_BIT);
    
    for(i=tTileY; i<tileAmount; i++)
    {
        tileDataCounter = tileList[i].tilePointer;
        for(j=0; j < tileList[i].xSize * tileList[i].ySize; j++)
        {
            if(x>=tileList[i].xSize)
            {
                x=0;
                y++;
            }
            glRasterPos2i(16*tZoom*x, 8*tZoom*y + i - tTileY);
            glCallList(listIndex + tileData[tileDataCounter]);
            x++;
            tileDataCounter++;
        }
        x=0;
        y++;
    }
    glFlush();
}

void tile_keypress(unsigned char key, int x, int y)
{
    switch(key)
    {
        case '+':
             if(tZoom<3) tZoom++;
             break;
        case '-':
             if(tZoom>1) tZoom--;
             break;
        default: return;
    }
    glutPostRedisplay();
}*/

#endif
