#include <GL/freeglut.h>
#include <GL/glu.h>
#include <GL/gl.h>

//#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

//#include "gl/freeglut.h"

int MAIN_WIN, SPRITE_WIN, TILE_WIN, OBJ_WIN;

#include "lem2zip/lem2zip.cpp"

//#include "L2Global.h"
#include "L2DefSprite.h"
#include "L2WMain.h"
#include "L2WSprite.h"
#include "L2WTile.h"
#include "L2WObject.h"
#include "L2LData.h"

#include "L2WMain.hpp"
#include "L2WSprite.hpp"
#include "L2WTile.hpp"
#include "L2WObject.hpp"

void display(void) {
    glClear(GL_COLOR_BUFFER_BIT);
    glFlush();
}

char* getStyleFileName(int ID) {
    char* nameBuffer;
    nameBuffer = (char*) malloc(256);

    FILE* StyleNames = fopen("l2stylef.txt", "r");
    if(StyleNames == NULL) return NULL;

    for(int i=0; i<=ID; i++) {
        fgets(nameBuffer, 256, StyleNames);
    }
    int i=0;
    while(nameBuffer[i] != '\n' && i<256) i++;

    nameBuffer[i] = '\0';
    
    return nameBuffer;
}

bool isCompressed(FILE* file) {
    char header[4];
    rewind(file);
    
    for(int i=0; i<4; i++) header[i] = fgetc(file);

    if(!strncmp(header, "GSCM", 4)) return true;
    else return false;
}

int main(int argc, char** argv)
{
    FILE* LevelFile;
    FILE* StyleFile;
    /* Initialize Lemmings Data */
    
    char levelFileName[256];
    strncpy(levelFileName, argv[1], 256);
    if(!(LevelFile=fopen(levelFileName, "rb+"))) return EXIT_FAILURE;
    if(isCompressed(LevelFile)) {
        fclose(LevelFile);
        lem2zip(levelFileName, L2Z_DECOMPRESS);
        if(!(LevelFile=fopen(levelFileName, "rb+"))) return EXIT_FAILURE;
    }
    //if(!(LevelFile=fopen("levels/Level110.dat", "rb+"))) return 0;
    fseek(LevelFile, 0x0066, SEEK_SET);
    int style = fgetc(LevelFile);
    char* styleFileName = getStyleFileName(style);
    if(!(StyleFile=fopen(styleFileName, "rb"))) return EXIT_FAILURE;
    bool styleCompressed = isCompressed(StyleFile);
    if(styleCompressed) {
        fclose(StyleFile);
        lem2zip(styleFileName, L2Z_DECOMPRESS);
        if(!(StyleFile=fopen(styleFileName, "rb+"))) return EXIT_FAILURE;
    }
    
    /* Initialize OpenGL */
    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_SINGLE | GLUT_RGBA);
    
    /* Initialize Main Window */
    SpriteData = new CDefSprite;
    MainWindow = new CWinMain(640, 400, 0, 0); //read from .ini
    SpriteData->GenerateSprites(StyleFile);
    SpriteWindow = new CWinSprite(128, 400, 648, 0);
    SpriteData->GenerateSprites(StyleFile);
    LevelData = new CLevelData(LevelFile);
    if(!(LevelData->PointerValidityCheck())) LevelData->ReadLevelData();
    TileWindow = new CWinTile(128, 400, 784, 0);
    SpriteData->GenerateSprites(StyleFile);
    TileData = new CDefTile;
    TileData->GenerateTiles(StyleFile);
    ObjectWindow = new CWinObject(128, 400, 920, 0);
    SpriteData->GenerateSprites(StyleFile);
    ObjectData = new CDefObject();
    ObjectData->CreateObjects(StyleFile);

    fclose(StyleFile);
    if(styleCompressed) lem2zip(styleFileName, L2Z_COMPRESS);

    glutSetWindow(MAIN_WIN);
    glutMainLoop();

    return EXIT_SUCCESS;
}
